unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls, HTTPSend;

type

  { TForm1 }

  TForm1 = class(TForm)
    Start: TButton;
    Stop: TButton;
    Memo1: TMemo;
    procedure StartClick(Sender: TObject);
    procedure StopClick(Sender: TObject);
  private
    { private declarations }
    procedure ThreadTerminates(Sender: TObject);
  public
    { public declarations }
  end; 
       { THTTPThread }

  THTTPThread=class(TThread)
  private
    fData: String;
    fURL: String;
    fHTTP: THTTPSend;
  protected
   procedure Execute; override;
  public
    procedure SoftAbort;
    procedure HardAbort;
    property URL:String read fURL write fURL;
    property Data:String read fData write fData;
  end;


var
  Form1: TForm1;
  MyThrd:THTTPThread;
  
  geschrieben:string;

implementation

{ TForm1 }

procedure TForm1.StartClick(Sender: TObject);
begin
  geschrieben:='ganz am anfang';
  MyThrd := THTTPThread.Create(True);
  MyThrd.OnTerminate := @ThreadTerminates;
  MyThrd.URL := 'http://www.lazarusforum.de';
  MyThrd.FreeOnTerminate := true;
  Memo1.Text:='Start'+#13;
  MyThrd.Data:='anfang data';
  MyThrd.Resume;
end;

procedure TForm1.StopClick(Sender: TObject);
begin
  if assigned(MyThrd) then
    begin
    Memo1.Text:=Memo1.Text+#13+'stop click';
    MyThrd.HardAbort;
    if assigned(MyThrd) then
      ShowMessage('Isr noch da...');
    end;
end;

procedure TForm1.ThreadTerminates(Sender: TObject);
begin
  Memo1.Text:=Memo1.Text+MyThrd.Data;
  Memo1.Text:=Memo1.Text+geschrieben;
  Memo1.Text:=Memo1.Text+#13+'ende';
  MyThrd:=nil;
end;


{ THTTPThread }

procedure THTTPThread.Execute;
var Success:boolean;
  i:integer;
begin
  fHTTP := THTTPSend.Create;
  try
    Success := fHTTP.HTTPMethod('GET', fURL);
    if Success then
    begin
     fHTTP.Document.Position := 0;
  geschrieben:='gleich';
     SetString(fData, PChar(fHTTP.Document.Memory), fHTTP.Document.Size);
  geschrieben:='jetzt';
    end;
  finally
    fHTTP.Free;
  end;
end;


procedure THTTPThread.SoftAbort;
begin
  Terminate;
  fHTTP.Abort; //stop flag setzen
end;

procedure THTTPThread.HardAbort;
begin
  SoftAbort;
  FreeAndNil(fHTTP);
end;

initialization
  {$I unit1.lrs}

end.
